local MAXTABS = 8
-- MAXTABS can be changed to create more or less tabs. Do not set lower than 2 or higher than 8
-- If max tabs is less than 5, set party functions will be disabled

local MINORVERSION = 7
local MAJORVERSION = 5
local DefaultSettings = {
	["Version"] = MAJORVERSION,
	["CurrentTab"] = 1,
	--["ExactTimestamps"] = 0,
	["UseMiniWindow"] = 1,
	["AutoSetParty"] = 0,
}
for x=1,MAXTABS do
	if x == 1 then
		DefaultSettings["Tab"..x.."Name"] = UnitName("player")
	else
		DefaultSettings["Tab"..x.."Name"] = "Custom"..x
	end
	DefaultSettings["Tab"..x.."Damage"] = 1
	DefaultSettings["Tab"..x.."Heals"] = 1
	DefaultSettings["Tab"..x.."Debuffs"] = 1
end
local WatchedNames = {}

local frame = CreateFrame("Frame","OuchFrame",UIParent)
local parser = CreateFrame("Frame")
frame:Hide()

frame:SetFrameStrata("DIALOG")
frame:SetWidth(600)
frame:SetHeight(320)
frame:SetPoint("CENTER",0,95)
frame:SetBackdrop( {
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = true, tileSize = 32, edgeSize = 32,
		insets = { left = 11, right = 12, top = 12, bottom = 11 }
	})
tinsert(UISpecialFrames,"OuchFrame")
frame:SetMovable(1)
frame:EnableMouse(1)
frame:SetClampedToScreen(1)
frame:RegisterForDrag("LeftButton")
frame:SetScript("OnDragStart", function(self) self:StartMoving() end)
frame:SetScript("OnDragStop", function(self)
	self:StopMovingOrSizing()
	local x,y = self:GetRect()
	OuchPos.mainwindowx,OuchPos.mainwindowy = x, y
	self:SetUserPlaced(0)
end)
frame:SetScript("OnShow",function() OuchMiniWindow:Hide() end)
frame:SetScript("OnHide",function()
	if OuchDB["UseMiniWindow"] == 1 then
		OuchMiniWindow:Show()
	end
end)

local miniwindow = CreateFrame("Button","OuchMiniWindow",UIParent)
miniwindow:SetFrameStrata("LOW")
miniwindow:SetWidth(38)
miniwindow:SetHeight(18)
miniwindow:SetMovable(1)
miniwindow:SetClampedToScreen(1)
miniwindow:SetBackdrop( {
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16,
	insets = { left = 5, right = 5, top = 5, bottom = 5 }
})
miniwindow:SetScript("OnClick", function() frame:Show() end)
miniwindow:RegisterForDrag("LeftButton")
miniwindow:SetScript("OnDragStart", function(self) self:StartMoving() end)
miniwindow:SetScript("OnDragStop", function(self)
	self:StopMovingOrSizing()
	local x,y = self:GetRect()
	OuchPos.miniwindowx,OuchPos.miniwindowy = x, y
	self:SetUserPlaced(0)
end)

local miniwindowtext = miniwindow:CreateFontString(nil,"OVERLAY","GameFontNormalSmall")
miniwindowtext:SetPoint("TOP",0,-3)
miniwindowtext:SetText("Ouch")

local titleartwork = frame:CreateTexture(nil,"ARTWORK")
titleartwork:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
titleartwork:SetWidth(350)
titleartwork:SetHeight(61)
titleartwork:SetPoint("TOP",0,12)

local titletext = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
titletext:SetPoint("TOP",0,0)

local versiontext = frame:CreateFontString(nil,"OVERLAY","GameFontNormalSmall")
versiontext:SetPoint("TOPRIGHT",-65,-15)
versiontext:SetText("|cffb4b4b4 Ouch v"..MAJORVERSION.."."..MINORVERSION.."|r")

local closebutton = CreateFrame("Button",nil,frame,"UIPanelCloseButton")
closebutton:SetPoint("TOPRIGHT",-7,-4)

local helpbutton = CreateFrame("Button",nil,frame)
helpbutton:SetHeight(29)
helpbutton:SetWidth(15)
helpbutton:SetPoint("TOPRIGHT",-40,0)
helpbutton:SetNormalTexture("Interface\\Buttons\\UI-MicroButton-Help-Up")
helpbutton:SetPushedTexture("Interface\\Buttons\\UI-MicroButton-Help-Down")
helpbutton:SetHighlightTexture("Interface\\Buttons\\UI-MicroButton-Hilight")
helpbutton:SetScript("OnEnter",function(self) GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT", -10, -10) GameTooltip:SetText("Click for list of slash commands") end)
helpbutton:SetScript("OnLeave",function() GameTooltip:Hide() end)
helpbutton:SetScript("OnClick",function()
	DEFAULT_CHAT_FRAME:AddMessage("Ouch Commands:")
	DEFAULT_CHAT_FRAME:AddMessage("  /ouch - Toggles main window")
	DEFAULT_CHAT_FRAME:AddMessage("  /ouch list - Displays a list of heals to ignore")
	DEFAULT_CHAT_FRAME:AddMessage("  /ouch ignore <HealName> - Adds to or removes a heal from the ignore list. This only works for heals!")
end)

--[[
local exacttimestampsbox = CreateFrame("CheckButton","OuchExactTimestampsBox",frame,"UICheckButtonTemplate")
exacttimestampsbox:SetWidth(20)
exacttimestampsbox:SetHeight(20)
exacttimestampsbox:SetPoint("TOPLEFT",14,-10)
exacttimestampsbox:SetScript("OnClick",function(self)
	if self:GetChecked() then
		OuchDB["ExactTimestamps"] = 1
	else
		OuchDB["ExactTimestamps"] = 0
	end
end)
OuchExactTimestampsBoxText:SetText("Exact Timestamps")
]]--

local useminiwindowbox = CreateFrame("CheckButton","OuchUseMiniwindowBox",frame,"UICheckButtonTemplate")
useminiwindowbox:SetWidth(20)
useminiwindowbox:SetHeight(20)
useminiwindowbox:SetPoint("TOPLEFT",14,-10)
useminiwindowbox:SetScript("OnClick",function(self)
	if self:GetChecked() then
		OuchDB["UseMiniWindow"] = 1
	else
		OuchDB["UseMiniWindow"] = 0
	end
end)
useminiwindowbox:SetScript("OnEnter",function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", 15, 2)
	GameTooltip:SetText("Collapses main window into a miniature button when closed.\nClick miniwindow to open main window.")
end)
useminiwindowbox:SetScript("OnLeave",function() GameTooltip:Hide() end)
OuchUseMiniwindowBoxText:SetText("Use Miniwindow")

local function OuchTabChange(tab)
	for x=1,MAXTABS do
		local button = _G["OuchTabButton"..x]
		local scrollingframe = _G["OuchScrollMsgFrame"..x]
		local tabunitname = ""
		if strlen(OuchDB["Tab"..x.."Name"]) > 10 then
			tabunitname = strsub(OuchDB["Tab"..x.."Name"],1,8)..".."
		else
			tabunitname = OuchDB["Tab"..x.."Name"]
		end
		if x == tab then
			button:Disable()
			scrollingframe:Show()
			--titletext:SetText("Ouch "..tabunitname.." Tab")
			titletext:SetText(tabunitname.."'s Tab")
		else
			button:Enable()
			scrollingframe:Hide()
		end
		button:SetText(tabunitname)
	end
	OuchDamageBox:SetID(tab)
	OuchDamageBox:SetChecked(OuchDB["Tab"..tab.."Damage"])
	OuchHealsBox:SetID(tab)
	OuchHealsBox:SetChecked(OuchDB["Tab"..tab.."Heals"])
	OuchDebuffsBox:SetID(tab)
	OuchDebuffsBox:SetChecked(OuchDB["Tab"..tab.."Debuffs"])
	OuchDB["CurrentTab"] = tab
end

local tabbuttonx = 13
for x=1,MAXTABS do
	local tabbutton = CreateFrame("Button","OuchTabButton"..x,frame,"OptionsButtonTemplate")
	tabbutton:SetPoint("BOTTOMLEFT",tabbuttonx,30)
	tabbuttonx = tabbuttonx + 70
	tabbutton:SetWidth(70)
	tabbutton:SetID(x)
	tabbutton:SetScript("OnClick",function(self)
		OuchTabChange(self:GetID())
	end)
	if x > 1 then
		tabbutton:SetScript("OnEnter",function(self)
			GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", 15, 2)
			GameTooltip:SetText("Custom Unit Tab. Enter a Unit's name into the box to set.")
		end)
		tabbutton:SetScript("OnLeave",function() GameTooltip:Hide() end)
	end

	local scrollingmsgframe = CreateFrame("ScrollingMessageFrame","OuchScrollMsgFrame"..x,frame)
	scrollingmsgframe:SetPoint("TOPLEFT",20,-28)
	scrollingmsgframe:SetPoint("BOTTOMRIGHT",-35,55)
	scrollingmsgframe:SetFontObject(ChatFontNormal)
	--scrollingmsgframe:SetInsertMode("BOTTOM")
	scrollingmsgframe:SetJustifyH("LEFT")
	scrollingmsgframe:SetFading(0)
	scrollingmsgframe:EnableMouseWheel(1)
	scrollingmsgframe:SetMaxLines(250)
	scrollingmsgframe:SetScript("OnHyperlinkClick",function(self, link, text, button)
		SetItemRef(link, text, button)
	end)
	scrollingmsgframe:SetScript("OnMouseWheel",function(self, firstarg)
		if IsShiftKeyDown() then
			if firstarg > 0 then
				self:ScrollToTop()
			elseif firstarg < 0 then
				self:ScrollToBottom()
			end
		else
			if firstarg > 0 then
				self:ScrollUp()
			elseif firstarg < 0 then
				self:ScrollDown()
			end
		end
	end)
	scrollingmsgframe:Hide()

	local upbutton = CreateFrame("Button",nil,scrollingmsgframe,"UIPanelScrollUpButtonTemplate")
	upbutton:SetPoint("TOPRIGHT",19,-1)
	upbutton:RegisterForClicks("LeftButtonUp","RightButtonUp")
	upbutton:SetScript("OnEnter",function(self) GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT", 10, -10) GameTooltip:SetText("Right click to scroll to top") end)
	upbutton:SetScript("OnLeave",function() GameTooltip:Hide() end)
	upbutton:SetScript("OnClick",function(_,button)
		if button == "RightButton" then
			scrollingmsgframe:ScrollToTop()
		else
			scrollingmsgframe:ScrollUp()
		end
	end)
	upbutton:SetScript("OnMouseDown",function(self,button)
		if button == "LeftButton" then
			self:SetScript("OnUpdate",function(self,elapsed)
				if not self.timer then
					self.timer = 0.06
				end
				self.timer = self.timer - elapsed
				if self.timer <= 0 then
					scrollingmsgframe:ScrollUp()
					self.timer = nil
				end
			end)
		end
	end)
	upbutton:SetScript("OnMouseUp",function(self) self:SetScript("OnUpdate",nil) end)

	local downbutton = CreateFrame("Button",nil,scrollingmsgframe,"UIPanelScrollDownButtonTemplate")
	downbutton:SetPoint("BOTTOMRIGHT",19,0)
	downbutton:SetScript("OnEnter",function(self) GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT", 10, -10) GameTooltip:SetText("Right click to scroll to bottom") end)
	downbutton:SetScript("OnLeave",function() GameTooltip:Hide() end)
	downbutton:RegisterForClicks("LeftButtonUp","RightButtonUp")
	downbutton:SetScript("OnClick",function(_,button)
		if button == "RightButton" then
			scrollingmsgframe:ScrollToBottom()
		else
			scrollingmsgframe:ScrollDown()
		end
	end)
	downbutton:SetScript("OnMouseDown",function(self,button)
		if button == "LeftButton" then
			self:SetScript("OnUpdate",function(self,elapsed)
				if not self.timer then
					self.timer = 0.06
				end
				self.timer = self.timer - elapsed
				if self.timer <= 0 then
					scrollingmsgframe:ScrollDown()
					self.timer = nil
				end
			end)
		end
	end)
	downbutton:SetScript("OnMouseUp",function(self) self:SetScript("OnUpdate",nil) end)

	scrollingmsgframe:SetScript("OnUpdate",function(self)
		if self:AtBottom() then
			downbutton:Disable()
		else
			downbutton:Enable()
		end
		if self:AtTop() then
			upbutton:Disable()
		else
			upbutton:Enable()
		end
	end)
end

local customnameinput = CreateFrame("EditBox",nil,frame,"InputBoxTemplate")
customnameinput:SetWidth(80)
customnameinput:SetHeight(26)
customnameinput:SetPoint("BOTTOMRIGHT",-65,8)
customnameinput:SetScript("OnEscapePressed",function(self) self:ClearFocus() end)
customnameinput:SetScript("OnEnterPressed",function(self)
	if self:GetText() ~= "" then
		if OuchDB["CurrentTab"] > 1 then
			local name = string.upper(string.sub(self:GetText(),1,1))..string.sub(self:GetText(),2)
			if WatchedNames[name] or name == UnitName("player") then
				DEFAULT_CHAT_FRAME:AddMessage(name.." already has a tab!")
			else
				OuchDB["Tab"..OuchDB["CurrentTab"].."Name"] = name
				WatchedNames = {}
				for x=2,MAXTABS do
					WatchedNames[OuchDB["Tab"..x.."Name"]] = x
				end
				OuchTabChange(OuchDB["CurrentTab"])
				_G["OuchScrollMsgFrame"..OuchDB["CurrentTab"]]:AddMessage("-------------------------")
				_G["OuchScrollMsgFrame"..OuchDB["CurrentTab"]]:AddMessage("Setting tab to "..name)
				_G["OuchScrollMsgFrame"..OuchDB["CurrentTab"]]:AddMessage("-------------------------")
			end
		end
	end
	self:ClearFocus()
end)
customnameinput:SetScript("OnEditFocusLost",function(self) self:SetText("") end)
customnameinput:SetAutoFocus(0)

local clearbutton = CreateFrame("Button",nil,frame,"OptionsButtonTemplate")
clearbutton:SetPoint("BOTTOMRIGHT",-13,10)
clearbutton:SetWidth(48)
clearbutton:SetText("Clear")
clearbutton:SetScript("OnEnter",function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", 15, 2)
	GameTooltip:SetText("Clears text from all tab windows.")
end)
clearbutton:SetScript("OnLeave",function() GameTooltip:Hide() end)
clearbutton:SetScript("OnClick",function()
	for x=1,MAXTABS do
		local box = _G["OuchScrollMsgFrame"..x]
		box:Show()
		box:Clear()
	end
	OuchTabChange(OuchDB["CurrentTab"])
end)

local setpartybutton = CreateFrame("Button",nil,frame,"OptionsButtonTemplate")
setpartybutton:SetPoint("BOTTOMRIGHT",-153,10)
setpartybutton:SetWidth(63)
setpartybutton:SetText("Set Party")
setpartybutton:SetScript("OnEnter",function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", 15, 2)
	GameTooltip:SetText("Sets the first five tabs to your party members.\nMust be in a party to function.")
end)
setpartybutton:SetScript("OnLeave",function() GameTooltip:Hide() end)
setpartybutton:SetScript("OnClick",function()
	Ouch_SetParty()
end)

local autobox = CreateFrame("CheckButton","OuchAutoBox",setpartybutton,"UICheckButtonTemplate")
autobox:SetWidth(20)
autobox:SetHeight(20)
autobox:SetPoint("LEFT",-43,-1)
autobox:SetScript("OnEnter",function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", 15, 2)
	GameTooltip:SetText("Auto sets first five tabs to party members.\nTabs might change order when players leave/join.")
end)
OuchAutoBoxText:SetText("Auto")
autobox:SetScript("OnLeave",function() GameTooltip:Hide() end)
autobox:SetScript("OnClick",function(self)
	if self:GetChecked() then
		OuchDB["AutoSetParty"] = 1
		frame:RegisterEvent("GROUP_ROSTER_UPDATE")
		Ouch_SetParty(1)
	else
		OuchDB["AutoSetParty"] = 0
		frame:UnregisterEvent("GROUP_ROSTER_UPDATE")
	end
end)

local OuchOptions = {
	[1] = {
		["BoxName"] = "Damage",
		["xOffset"] = 12,
		["Text"] = "Damage",
		["TooltipText"] = "Displays all damage taken by this tab's unit",
		["PlayerOnly"] = false,
	},
	[2] = {
		["BoxName"] = "Heals",
		["Text"] = "Heals",
		["xOffset"] = 80,
		["TooltipText"] = "Displays all heals recieved by this tab's unit",
		["PlayerOnly"] = false,
	},
	[3] = {
		["BoxName"] = "Debuffs",
		["Text"] = "Debuffs",
		["xOffset"] = 135,
		["TooltipText"] = "Displays all debuffs gained or faded on this tab's unit",
		["PlayerOnly"] = false,
	},
}

for k,v in pairs(OuchOptions) do
	local checkbox = CreateFrame("CheckButton","Ouch"..OuchOptions[k]["BoxName"].."Box",frame,"UICheckButtonTemplate")
	checkbox:SetWidth(20)
	checkbox:SetHeight(20)
	checkbox:SetPoint("BOTTOMLEFT",frame,"BOTTOMLEFT",OuchOptions[k]["xOffset"],10)
	if OuchOptions[k]["PlayerOnly"] then
		checkbox:SetParent(OuchScrollMsgFrame1)
		DefaultSettings[OuchOptions[k]["BoxName"]] = false
		checkbox:SetScript("OnShow",function(self)
			self:SetScript("OnShow",nil)
			self:SetChecked(OuchDB[OuchOptions[k]["BoxName"]])
		end)
		checkbox:SetScript("OnClick",function(self)
			if self:GetChecked() then
				OuchDB[OuchOptions[k]["BoxName"]] = 1
			else
				OuchDB[OuchOptions[k]["BoxName"]] = 0
			end
		end)
	else
		checkbox:SetScript("OnClick",function(self)
			if self:GetChecked() then
				OuchDB["Tab"..self:GetID()..OuchOptions[k]["BoxName"]] = 1
			else
				OuchDB["Tab"..self:GetID()..OuchOptions[k]["BoxName"]] = 0
			end
		end)
	end
	checkbox:SetScript("OnEnter",function(self)
		GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", 15, 2)
		GameTooltip:SetText(OuchOptions[k]["TooltipText"])
	end)
	checkbox:SetScript("OnLeave",function() GameTooltip:Hide() end)
	_G["Ouch"..OuchOptions[k]["BoxName"].."BoxText"]:SetText(OuchOptions[k]["Text"])
end

function Ouch_SetParty(auto)
	if GetNumSubgroupMembers() > 0 then
		for x=1,4 do
			if UnitName("party"..x) then
				local name = GetUnitName("party"..x,1)
				if strfind(name,"-") then
					name = gsub(name," ","",2)
				end
				if OuchDB["Tab"..(x + 1).."Name"] ~= name then
					if name ~= "Unknown" then
						_G["OuchScrollMsgFrame"..(x + 1)]:AddMessage("-------------------------")
						_G["OuchScrollMsgFrame"..(x + 1)]:AddMessage("Setting tab to "..name)
						_G["OuchScrollMsgFrame"..(x + 1)]:AddMessage("-------------------------")
					end
				end
				OuchDB["Tab"..(x + 1).."Name"] = name
			else
				OuchDB["Tab"..(x + 1).."Name"] = "Party"..(x + 1)
			end
		end
		WatchedNames = {}
		for x=2,MAXTABS do
			WatchedNames[OuchDB["Tab"..x.."Name"]] = x
		end
		OuchTabChange(OuchDB["CurrentTab"])
	elseif not auto then
		DEFAULT_CHAT_FRAME:AddMessage("You must be in a party for this function to work.")
	end
end

function Ouch_SlashCommands(msg)
	msg = string.upper(msg)
	if msg == "" then
		if frame:IsVisible() then
			frame:Hide()
		else
			frame:Show()
		end
	elseif string.sub(msg, 1,4) == "LIST" then
		DEFAULT_CHAT_FRAME:AddMessage("Ignoring the following heals:")
		for k,v in pairs(OuchIgnoreHealList) do
			DEFAULT_CHAT_FRAME:AddMessage("\""..k.."\"")
		end
	elseif string.sub(msg, 1,6) == "IGNORE" then
		msg = string.sub(msg, 8)
		if OuchIgnoreHealList[msg] then
			OuchIgnoreHealList[msg] = nil
			DEFAULT_CHAT_FRAME:AddMessage("\""..msg.."\" removed from ignore list")
		else
			DEFAULT_CHAT_FRAME:AddMessage("\""..msg.."\" added to ignore list")
			OuchIgnoreHealList[msg] = true
		end
	end
end

frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent",function(self, event)
	if event == "GROUP_ROSTER_UPDATE" then
		Ouch_SetParty(1)
	elseif event == "ADDON_LOADED" then
		self:UnregisterEvent("ADDON_LOADED")
		SlashCmdList["OUCHSLASH"] = Ouch_SlashCommands
		SLASH_OUCHSLASH1 = "/ouch"
		if not OuchPos then
			OuchPos = {}
		end
		if OuchPos.mainwindowx then
			frame:SetPoint("BOTTOMLEFT",nil,"BOTTOMLEFT",OuchPos.mainwindowx,OuchPos.mainwindowy)
		else
			frame:SetPoint("CENTER",0,95)
		end
		if OuchPos.miniwindowx then
			miniwindow:SetPoint("BOTTOMLEFT",nil,"BOTTOMLEFT",OuchPos.miniwindowx,OuchPos.miniwindowy)
		else
			miniwindow:SetPoint("CENTER",0,95)
		end
		if not OuchIgnoreHealList then
			OuchIgnoreHealList = {}
		end
		if not OuchDB then
			OuchDB = {}
			for k,v in pairs(DefaultSettings) do
				OuchDB[k] = v
			end
		elseif OuchDB["Version"] ~= MAJORVERSION then
			OuchDB = {}
			for k,v in pairs(DefaultSettings) do
				OuchDB[k] = v
			end
			DEFAULT_CHAT_FRAME:AddMessage("Ouch updated. Settings have been reset.")
		else
			local VarCheck = {}
			for k,v in pairs(DefaultSettings) do
				VarCheck[k] = true
				if not OuchDB[k] then
					OuchDB[k] = v
				end
			end
			for k,v in pairs(OuchDB) do
				if not VarCheck[k] then
					OuchDB[k] = nil
				end
			end
			OuchDB["Tab1Name"] = UnitName("player")
		end
		for x=2,MAXTABS do
			WatchedNames[OuchDB["Tab"..x.."Name"]] = x
		end
		if OuchDB["CurrentTab"] > MAXTABS then
			OuchDB["CurrentTab"] = 1
		end
		OuchTabChange(OuchDB["CurrentTab"])
		if MAXTABS < 5 then
			setpartybutton:Hide()
			OuchDB["AutoSetParty"] = 0
		end
		--OuchExactTimestampsBox:SetChecked(OuchDB["ExactTimestamps"])
		OuchUseMiniwindowBox:SetChecked(OuchDB["UseMiniWindow"])
		if OuchDB["UseMiniWindow"] == 0 then
			miniwindow:Hide()
		end
		OuchAutoBox:SetChecked(OuchDB["AutoSetParty"])
		if OuchDB["AutoSetParty"] == 1 then
			frame:RegisterEvent("GROUP_ROSTER_UPDATE")
			Ouch_SetParty(1)
		end
	end
end)

local SchoolType = {
	[1] = "Physical",
	[2] = "Holy",
	[4] = "Fire",
	[8] = "Nature",
	[16] = "Frost",
	[32] = "Shadow",
	--[40] = "Nature+Shadow",
	[64] = "Arcane",
}
local function SchoolDamType(school)
	if SchoolType[school] then
		return SchoolType[school]
	else
		return "MixedDamage"
	end
end

local LineColors = {
	["AutoAttack"] = "|cffff4040",
	["SpellAttack"] = "|cffff80ff",
	["Heal"] = "|cff40ff40",
	["Debuff"] = "|cff00ffff",
}

parser:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
parser:SetScript("OnEvent",function(_, event, timestamp, subevent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, ...)
	local unit, tab, message, changetype, hittype
	if destGUID == UnitGUID("player") then
		if OuchDB["Tab1Heals"] == 1 or OuchDB["Tab1Damage"] == 1 or OuchDB["Tab1Debuffs"] == 1 then
			unit = "player"
			tab = 1
		end
	elseif UnitInVehicle("player") and destGUID == UnitGUID("pet") then
		if OuchDB["Tab1Heals"] == 1 or OuchDB["Tab1Damage"] == 1 or OuchDB["Tab1Debuffs"] == 1 then
			unit = "pet"
			tab = 1
		end
	elseif WatchedNames[destName] then
		if OuchDB["Tab"..WatchedNames[destName].."Heals"] == 1 or OuchDB["Tab"..WatchedNames[destName].."Damage"] == 1 or OuchDB["Tab"..WatchedNames[destName].."Debuffs"] == 1 then
			unit = destName
			tab = WatchedNames[destName]
		end
	end
	if unit then
		if unit == "pet" then
			destName = "Vehicle"
		end
		if not sourceName then
			sourceName = "Unknown"
		end
		if subevent == "SWING_DAMAGE" then
			local amount, overdamage, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			changetype = "Damage"
			message = LineColors["AutoAttack"]
			if critical then
				hittype = "*crits*"
			elseif crushing then
				hittype = "+crushes+"
			elseif glancing then
				hittype = "-glances-"
			else
				hittype = "hits"
			end
			if overdamage > 0 then
				amount = amount - overdamage
				message = message..sourceName.." "..hittype.." "..destName.." for "..amount.." "..SchoolDamType(school)..". ("..overdamage.." overkill)"
			else
				message = message..sourceName.." "..hittype.." "..destName.." for "..amount.." "..SchoolDamType(school).."."
			end
			if resisted then
				message = message.." ("..resisted.." resisted)"
			end
			if blocked then
				message = message.." ("..blocked.." blocked)"
			end
			if absorbed then
				message = message.." ("..absorbed.." absorbed)"
			end
		elseif subevent == "SWING_MISSED" then
			local missType, _, absorbed = ...
			changetype = "Damage"
			if missType == "ABSORB" then
				message = LineColors["AutoAttack"]..sourceName.." misses "..destName..". ("..string.lower(missType).." "..absorbed..")"
			else
				message = LineColors["AutoAttack"]..sourceName.." misses "..destName..". ("..string.lower(missType)..")"
			end
		elseif subevent == "RANGE_DAMAGE" then
			local spellId, spellName, spellSchool, amount, overdamage, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			changetype = "Damage"
			message = LineColors["AutoAttack"]
			if critical then
				hittype = "*crits*"
			elseif crushing then
				hittype = "+crushes+"
			elseif glancing then
				hittype = "-glances-"
			else
				hittype = "hits"
			end
			if overdamage > 0 then
				amount = amount - overdamage
				message = message..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h "..hittype.." "..destName.." for "..amount.." "..SchoolDamType(school)..". ("..overdamage.." overkill)"
			else
				message = message..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h "..hittype.." "..destName.." for "..amount.." "..SchoolDamType(school).."."
			end
			if resisted then
				message = message.." ("..resisted.." resisted)"
			end
			if absorbed then
				message = message.." ("..absorbed.." absorbed)"
			end
		elseif subevent == "RANGE_MISSED" then
			local spellId, spellName, spellSchool, missType, _, absorbed = ...
			changetype = "Damage"
			if missType == "ABSORB" then
				message = LineColors["SpellAttack"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h misses "..destName..". ("..string.lower(missType).." "..absorbed..")"
			else
				message = LineColors["SpellAttack"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h misses "..destName..". ("..string.lower(missType)..")"
			end
		elseif subevent == "SPELL_DAMAGE" or subevent == "DAMAGE_SHIELD" then
			local spellId, spellName, spellSchool, amount, overdamage, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			changetype = "Damage"
			message = LineColors["SpellAttack"]
			if critical then
				hittype = "*crits*"
			else
				hittype = "hits"
			end
			if overdamage > 0 then
				amount = amount - overdamage
				message = message..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h "..hittype.." "..destName.." for "..amount.." "..SchoolDamType(school)..". ("..overdamage.." overkill)"
			else
				message = message..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h "..hittype.." "..destName.." for "..amount.." "..SchoolDamType(school).."."
			end
			if resisted then
				message = message.." ("..resisted.." resisted)"
			end
			if absorbed then
				message = message.." ("..absorbed.." absorbed)"
			end
		elseif subevent == "SPELL_MISSED" or subevent == "DAMAGE_SHIELD_MISSED" then
			local spellId, spellName, spellSchool, missType, _, absorbed = ...
			changetype = "Damage"
			if missType == "ABSORB" then
				message = LineColors["SpellAttack"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h misses "..destName..". ("..string.lower(missType).." "..absorbed..")"
			else
				message = LineColors["SpellAttack"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h misses "..destName..". ("..string.lower(missType)..")"
			end
		elseif subevent == "SPELL_PERIODIC_DAMAGE" then
			local spellId, spellName, spellSchool, amount, overdamage, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			changetype = "Damage"
			if overdamage > 0 then
				amount = amount - overdamage
				message = LineColors["SpellAttack"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h ticks on "..destName.." for "..amount.." "..SchoolDamType(school)..". ("..overdamage.." overkill)"
			else
				message = LineColors["SpellAttack"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h ticks on "..destName.." for "..amount.." "..SchoolDamType(school).."."
			end
			if resisted then
				message = message.." ("..resisted.." resisted)"
			end
			if absorbed then
				message = message.." ("..absorbed.." absorbed)"
			end
		elseif subevent == "SPELL_PERIODIC_MISSED" then
			local spellId, spellName, spellSchool, missType = ...
			changetype = "Damage"
			message = LineColors["SpellAttack"]
			message = message..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h misses "..destName..". ("..string.lower(missType)..")"
		elseif subevent == "ENVIRONMENTAL_DAMAGE" then
			local environmentalType, amount, overdamage, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			changetype = "Damage"
			if overdamage > 0 then
				amount = amount - overdamage
				message = LineColors["SpellAttack"]..destName.." suffers "..amount.." environmental "..string.lower(environmentalType).." damage. ("..overdamage.." overkill)"
			else
				message = LineColors["SpellAttack"]..destName.." suffers "..amount.." environmental "..string.lower(environmentalType).." damage."
			end
			if resisted then
				message = message.." ("..resisted.." resisted)"
			end
			if absorbed then
				message = message.." ("..absorbed.." absorbed)"
			end
		elseif subevent == "SPELL_DRAIN" or subevent == "SPELL_LEECH" or subevent == "SPELL_PERIODIC_DRAIN" or subevent == "SPELL_PERIODIC_LEECH" then
			local spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
			changetype = "Damage"
			message = LineColors["SpellAttack"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h drains "..amount.." "..powerType.." from "..destName.."."
		elseif subevent == "DAMAGE_SPLIT" then
			local spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
			changetype = "Damage"
			message = LineColors["SpellAttack"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h splits "..amount.." "..SchoolDamType(school).." damage with "..destName.."."
			if resisted then
				message = message.." ("..resisted.." resisted)"
			end
			if absorbed then
				message = message.." ("..absorbed.." absorbed)"
			end
		elseif subevent == "SPELL_HEAL" then
			local spellId, spellName, spellSchool, amount, overheal, absorbed, critical = ...
			if not OuchIgnoreHealList[string.upper(spellName)] then
				changetype = "Heal"
				if critical then
					hittype = "*crit heals*"
				else
					hittype = "heals"
				end
				if overheal > 0 then
					amount = amount - overheal
					message = LineColors["Heal"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h "..hittype.." "..destName.." for "..amount..". ("..overheal.." overheal)"
				else
					message = LineColors["Heal"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h "..hittype.." "..destName.." for "..amount.."."
				end
			end
		elseif subevent == "SPELL_PERIODIC_HEAL" then
			local spellId, spellName, spellSchool, amount, overheal, absorbed, critical = ...
			if not OuchIgnoreHealList[string.upper(spellName)] then
				changetype = "Heal"
				if overheal > 0 then
					amount = amount - overheal
				end
				message = LineColors["Heal"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h ticks on "..destName.." for "..amount.."."
				if overheal > 0 then
					message = message.." ("..overheal.." overheal)"
				end
			end
		elseif subevent == "SPELL_AURA_APPLIED" then
			local spellId, spellName, spellSchool, auraType = ...
			if auraType == "DEBUFF" then
				changetype = "Debuff"
				message = LineColors["Debuff"]..destName.." is afflicted by "..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h."
			end
		elseif subevent == "SPELL_AURA_APPLIED_DOSE" then
			local spellId, spellName, spellSchool, auraType, amount = ...
			if auraType == "DEBUFF" then
				changetype = "Debuff"
				message = LineColors["Debuff"]..destName.." is afflicted by "..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.." ("..amount..")|h."
			end
		elseif subevent == "SPELL_AURA_REMOVED" then
			local spellId, spellName, spellSchool, auraType = ...
			if auraType == "DEBUFF" then
				changetype = "Debuff"
				message = LineColors["Debuff"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.."|h fades from "..destName.."."
			end
		elseif subevent == "SPELL_AURA_REMOVED_DOSE" then
			local spellId, spellName, spellSchool, auraType, amount = ...
			if auraType == "DEBUFF" then
				changetype = "Debuff"
				message = LineColors["Debuff"]..sourceName.."'s |Hspell:"..spellId.."|h"..spellName.." ("..amount..")|h lowers on "..destName.."."
			end
		elseif subevent == "UNIT_DIED" then
			changetype = "Damage"
			message = "* * * * * "..destName.." died ! * * * * *"
		end
		if message then
			if OuchDB["Tab"..tab.."Heals"] == 1 and changetype == "Heal" or OuchDB["Tab"..tab.."Damage"] == 1 and changetype == "Damage" or OuchDB["Tab"..tab.."Debuffs"] == 1 and changetype == "Debuff" then
				--if OuchDB["ExactTimestamps"] == 1 then
				--	timestamp = "["..timestamp.."] "
				--else
					timestamp = "["..date("%I")..":"..date("%M")..":"..date("%S").."] "
				--end
				_G["OuchScrollMsgFrame"..tab]:AddMessage(timestamp..message.."|r")
			end
		end
	end
end)