local OuchMiniMapButton = CreateFrame("Button","OuchMiniMapButton", Minimap)
OuchMiniMapDB = {}

function OuchMiniMapButton:OnLoad()
	self:SetWidth(31)
	self:SetHeight(31)
	self:SetFrameStrata("BACKGROUND")
	self:SetFrameLevel(4)
	self:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
	self.icon = self:CreateTexture(nil, "BACKGROUND")
	self.icon:SetTexture("Interface\\Icons\\Spell_Shadow_LifeDrain")
	self.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
	self.icon:SetWidth(20)
	self.icon:SetHeight(20)
	self.icon:SetPoint("TOPLEFT", self, "TOPLEFT", 7, -5)
	self.overlay = self:CreateTexture(nil,"OVERLAY")
	self.overlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
	self.overlay:SetWidth(53)
	self.overlay:SetHeight(53)
	self.overlay:SetPoint("TOPLEFT",self,"TOPLEFT")
	self:EnableMouse(true)
	self:SetScript("OnEvent",function(self, event)
		if event == "ADDON_LOADED" then
			self:UnregisterEvent("ADDON_LOADED")
			OuchMiniMapButton:Move_Icon()
			if not OuchMiniMapDB.ButtonEnabled then
				OuchMiniMapDB.ButtonEnabled = 0
				self.enabledbox:SetChecked(false)
				self:Hide()
			end
			if (OuchMiniMapDB.ButtonEnabled == 1) then
				self:Show()
				self.enabledbox:SetChecked()
			else
				self:Hide()
				self.enabledbox:SetChecked(false)
			end
		end
	end)
	self:RegisterEvent("ADDON_LOADED")

	self:SetScript("OnEnter",function(self)
		GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT")
		GameTooltip:SetText("|cFFFFCC00Click: Toggle Ouch window\nDrag: Moves icon|r")
	end)
	self:SetScript("OnLeave",function() GameTooltip:Hide() end)
	self:RegisterForClicks("LeftButtonUp","RightButtonUp")
	self:SetScript("OnClick", function(self, button)
		--if button == "LeftButton" then
			if OuchFrame:IsVisible() then
				OuchFrame:Hide()
			else
				OuchFrame:Show()
			end
		--end
	end)
	self:RegisterForDrag("LeftButton")
	self:SetScript("OnDragStart", function()
		self:LockHighlight()
		self:SetScript("OnUpdate", function() self:IconDragging() end)
	end)
	self:SetScript("OnDragStop", function()
		self:SetScript("OnUpdate", nil)
		self:UnlockHighlight()
	end)

	self.enabledbox = CreateFrame("CheckButton","OuchUseMinimapButtonBox",OuchFrame,"UICheckButtonTemplate")
	self.enabledbox:SetWidth(20)
	self.enabledbox:SetHeight(20)
	self.enabledbox:SetPoint("TOPLEFT",120,-10)
	self.enabledbox:SetScript("OnClick",function(self)
		if self:GetChecked() then
			OuchMiniMapDB.ButtonEnabled = 1
			OuchMiniMapButton:Show()
		else
			OuchMiniMapDB.ButtonEnabled = 0
			OuchMiniMapButton:Hide()
		end
	end)
	self.enabledbox:SetScript("OnEnter",function(self)
		GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", 15, 2)
		GameTooltip:SetText("Adds a button to the minimap to open or close the main window.")
	end)
	self.enabledbox:SetScript("OnLeave",function() GameTooltip:Hide() end)
	OuchUseMinimapButtonBoxText:SetText("Use Minimap")
end

function OuchMiniMapButton:IconDragging()
	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()

	xpos = xmin-xpos/Minimap:GetEffectiveScale()+70
	ypos = ypos/Minimap:GetEffectiveScale()-ymin-70

	OuchMiniMapDB.IconPos = math.deg(math.atan2(ypos,xpos))
	self:Move_Icon()
end

function OuchMiniMapButton:Move_Icon()
	local angle = OuchMiniMapDB.IconPos or -86
	local xpos = 80*cos(angle)
	local ypos = 80*sin(angle)

	self:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-xpos,ypos-52)
end

OuchMiniMapButton:OnLoad()